﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Petzold.VectorGeometry;

namespace RandomGlobules
{
    public partial class MainPage : UserControl
    {
        Random rand = new Random();

        public MainPage()
        {
            InitializeComponent();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            while (LayoutRoot.Children.Count > 1)
                LayoutRoot.Children.RemoveAt(1);

            int width = (int)LayoutRoot.ActualWidth / 2;
            int height = (int)LayoutRoot.ActualHeight / 2;

            // Three control points
            Point pt1 = new Point(rand.Next(width), rand.Next(height));
            Point pt3 = new Point(rand.Next(width), rand.Next(height));
            Point pt5 = new Point(rand.Next(width), rand.Next(height));

            // Three end-points
            Point pt0 = RandomBetweenPoint(pt5, pt1);
            Point pt2 = RandomBetweenPoint(pt1, pt3);
            Point pt4 = RandomBetweenPoint(pt3, pt5);

            PathGeometry pathGeometry = new PathGeometry();

            PathFigure pathFigure = new PathFigure()
            {
                StartPoint = pt0,
                IsClosed = true
            };
            pathGeometry.Figures.Add(pathFigure);

            PolyQuadraticBezierSegment polyQuadBezierSegment = new PolyQuadraticBezierSegment();
            polyQuadBezierSegment.Points.Add(pt1);
            polyQuadBezierSegment.Points.Add(pt2);
            polyQuadBezierSegment.Points.Add(pt3);
            polyQuadBezierSegment.Points.Add(pt4);
            polyQuadBezierSegment.Points.Add(pt5);
            polyQuadBezierSegment.Points.Add(pt0);
            pathFigure.Segments.Add(polyQuadBezierSegment);

            Path path = new Path();
            path.Fill = new SolidColorBrush(Colors.LightGray);
            path.Data = pathGeometry;

            LayoutRoot.Children.Add(path);


            // Just the dotted line!

            SolidColorBrush blueBrush = new SolidColorBrush(Colors.Blue);
            DoubleCollection dashArray = new DoubleCollection();
            dashArray.Add(2);
            dashArray.Add(2);
            TranslateTransform translateTransform = new TranslateTransform()
            {
                X = width
            };

            Line line = new Line()
            {
                X1 = pt1.X,
                Y1 = pt1.Y,
                X2 = pt3.X,
                Y2 = pt3.Y,
                Stroke = blueBrush,
                StrokeDashArray = dashArray,
                RenderTransform = translateTransform
            };
            LayoutRoot.Children.Add(line);

            dashArray = new DoubleCollection();
            dashArray.Add(2);
            dashArray.Add(2);

            line = new Line()
            {
                X1 = pt3.X,
                Y1 = pt3.Y,
                X2 = pt5.X,
                Y2 = pt5.Y,
                Stroke = blueBrush,
                StrokeDashArray = dashArray,
                RenderTransform = translateTransform
            };
            LayoutRoot.Children.Add(line);

            dashArray = new DoubleCollection();
            dashArray.Add(2);
            dashArray.Add(2);

            line = new Line()
            {
                X1 = pt5.X,
                Y1 = pt5.Y,
                X2 = pt1.X,
                Y2 = pt1.Y,
                Stroke = blueBrush,
                StrokeDashArray = dashArray,
                RenderTransform = translateTransform
            };
            LayoutRoot.Children.Add(line);




            // Dotted line and points

            translateTransform = new TranslateTransform()
            {
                Y = height
            };

            dashArray = new DoubleCollection();
            dashArray.Add(2);
            dashArray.Add(2);

            line = new Line()
            {
                X1 = pt1.X,
                Y1 = pt1.Y,
                X2 = pt3.X,
                Y2 = pt3.Y,
                Stroke = blueBrush,
                StrokeDashArray = dashArray,
                RenderTransform = translateTransform
            };
            LayoutRoot.Children.Add(line);

            dashArray = new DoubleCollection();
            dashArray.Add(2);
            dashArray.Add(2);

            line = new Line()
            {
                X1 = pt3.X,
                Y1 = pt3.Y,
                X2 = pt5.X,
                Y2 = pt5.Y,
                Stroke = blueBrush,
                StrokeDashArray = dashArray,
                RenderTransform = translateTransform
            };
            LayoutRoot.Children.Add(line);

            dashArray = new DoubleCollection();
            dashArray.Add(2);
            dashArray.Add(2);

            line = new Line()
            {
                X1 = pt5.X,
                Y1 = pt5.Y,
                X2 = pt1.X,
                Y2 = pt1.Y,
                Stroke = blueBrush,
                StrokeDashArray = dashArray,
                RenderTransform = translateTransform
            };
            LayoutRoot.Children.Add(line);

            SolidColorBrush redBrush = new SolidColorBrush(Colors.Red);

            path = new Path()
            {
                Fill = redBrush,
                Data = new EllipseGeometry()
                {
                    Center = pt0,
                    RadiusX = 3,
                    RadiusY = 3
                },
                RenderTransform = translateTransform
            };
            LayoutRoot.Children.Add(path);

            path = new Path()
            {
                Fill = redBrush,
                Data = new EllipseGeometry()
                {
                    Center = pt2,
                    RadiusX = 3,
                    RadiusY = 3
                },
                RenderTransform = translateTransform
            };
            LayoutRoot.Children.Add(path);
            path = new Path()
            {
                Fill = redBrush,
                Data = new EllipseGeometry()
                {
                    Center = pt4,
                    RadiusX = 3,
                    RadiusY = 3
                },
                RenderTransform = translateTransform
            };
            LayoutRoot.Children.Add(path);



            // Dotted line and points and object

            translateTransform = new TranslateTransform()
            {
                X = width,
                Y = height
            };

            pathGeometry = new PathGeometry();

            pathFigure = new PathFigure()
            {
                StartPoint = pt0,
                IsClosed = true
            };
            pathGeometry.Figures.Add(pathFigure);

            polyQuadBezierSegment = new PolyQuadraticBezierSegment();
            polyQuadBezierSegment.Points.Add(pt1);
            polyQuadBezierSegment.Points.Add(pt2);
            polyQuadBezierSegment.Points.Add(pt3);
            polyQuadBezierSegment.Points.Add(pt4);
            polyQuadBezierSegment.Points.Add(pt5);
            polyQuadBezierSegment.Points.Add(pt0);
            pathFigure.Segments.Add(polyQuadBezierSegment);

            path = new Path()
            {
                Fill = new SolidColorBrush(Colors.LightGray),
                Data = pathGeometry,
                RenderTransform = translateTransform
            };

            LayoutRoot.Children.Add(path);

            dashArray = new DoubleCollection();
            dashArray.Add(2);
            dashArray.Add(2);

            line = new Line()
            {
                X1 = pt1.X,
                Y1 = pt1.Y,
                X2 = pt3.X,
                Y2 = pt3.Y,
                Stroke = blueBrush,
                StrokeDashArray = dashArray,
                RenderTransform = translateTransform
            };
            LayoutRoot.Children.Add(line);

            dashArray = new DoubleCollection();
            dashArray.Add(2);
            dashArray.Add(2);

            line = new Line()
            {
                X1 = pt3.X,
                Y1 = pt3.Y,
                X2 = pt5.X,
                Y2 = pt5.Y,
                Stroke = blueBrush,
                StrokeDashArray = dashArray,
                RenderTransform = translateTransform
            };
            LayoutRoot.Children.Add(line);

            dashArray = new DoubleCollection();
            dashArray.Add(2);
            dashArray.Add(2);

            line = new Line()
            {
                X1 = pt5.X,
                Y1 = pt5.Y,
                X2 = pt1.X,
                Y2 = pt1.Y,
                Stroke = blueBrush,
                StrokeDashArray = dashArray,
                RenderTransform = translateTransform
            };
            LayoutRoot.Children.Add(line);


            path = new Path()
            {
                Fill = redBrush,
                Data = new EllipseGeometry()
                {
                    Center = pt0,
                    RadiusX = 3,
                    RadiusY = 3
                },
                RenderTransform = translateTransform
            };
            LayoutRoot.Children.Add(path);

            path = new Path()
            {
                Fill = redBrush,
                Data = new EllipseGeometry()
                {
                    Center = pt2,
                    RadiusX = 3,
                    RadiusY = 3
                },
                RenderTransform = translateTransform
            };
            LayoutRoot.Children.Add(path);
            path = new Path()
            {
                Fill = redBrush,
                Data = new EllipseGeometry()
                {
                    Center = pt4,
                    RadiusX = 3,
                    RadiusY = 3
                },
                RenderTransform = translateTransform
            };
            LayoutRoot.Children.Add(path);






        }
        Point RandomBetweenPoint(Point pt1, Point pt2)
        {
            double t = rand.NextDouble();

            return new Point(pt1.X * (1 - t) + pt2.X * t,
                             pt1.Y * (1 - t) + pt2.Y * t);
        }
    }
}
